#include <cstdio>
#include <cstdlib>
#include <map>
#include <queue>
#include <iostream>

#define INF 10e20
using namespace std;

class point3d {
  public:
  point3d( int x, int y, int z ) : m_x(x), m_y(y),m_z(z) {
    
  }
  bool operator < ( const point3d & p ) const{
    if( m_x != p.m_x)
    return m_x < p.m_x;
  if( m_y != p.m_y ) 
    return m_y < p.m_y;
  return m_z < p.m_z;
  }
  friend ostream & operator <<( ostream & os, const point3d & point ) {
   os << point.m_x << " " << point.m_y << " " << point.m_z << endl;
   return ostream;
  }
  int m_x,m_y,m_z;
};

/*bool cmpr( const point3d& lhs, const point3d& rhs ) {
  if( lhs.m_x != rhs.m_x)
    return lhs.m_x < rhs.m_x;
  if( lhs.m_y != rhs.m_y ) 
    return lhs.m_y < rhs.m_y;
  return lhs.m_z < rhs.m_z;
}*/

class visit {
  public:
    visit( point3d & point, point3d & vect) : m_point(point), m_vect( vect){}
    point3d m_point;
    point3d m_vect;
};

int main( int argc, char ** argv ) {
  int n, s, t;
  while( scanf("%d%d%d", &n, &s, &t )==3) {
    multimap<point3d,point3d> edges;
    map<point3d,double>  nodes;
    int x,y,z,xt,yt,zt;
    scanf("%d%d%d%d%d%d", &x, &y, &z, &xt, &yt, &zt );
    point3d inital(x,y,z);
    point3d final(xt,yt,zt);
    while(n--) {
      scanf("%d%d%d%d%d%d", &x,&y,&z,&xt,&yt,&zt);
      point3d p1(x,y,z);
      point3d p2(xt,yt,zt);
      edges.insert(make_pair(p1,p2));
      edges.insert(make_pair(p2,p1));
      nodes.insert(make_pair(p1, INF));
      nodes.insert(make_pair(p2, INF));
    }
    
    for( multimap<point3d,point3d>::iterator i = edges.find( initial ); i != edges.end(); i++ )
    {
      cout << (*i).first << endl;
    }
    
    
  }
  return 0;
}